Index: src/web100srv.h
===================================================================
--- src/web100srv.h	(revision 796)
+++ src/web100srv.h	(working copy)
@@ -19,6 +19,9 @@
 #ifdef HAVE_LIBWEB100
 #include  <web100.h>
 #endif
+#ifdef HAVE_LIBTCPE
+#include <tcpe.h>
+#endif
 #ifdef HAVE_LIBPCAP
 #include  <pcap.h>
 #endif
@@ -190,6 +193,54 @@
   u_int16_t speed[32];
 } iflist;
 
+typedef int tcp_stat_var;
+
+struct tcp_vars {
+  tcp_stat_var Timeouts;
+  tcp_stat_var SumRTT;
+  tcp_stat_var CountRTT;
+  tcp_stat_var PktsRetrans;
+  tcp_stat_var FastRetran;
+  tcp_stat_var DataPktsOut;
+  tcp_stat_var AckPktsOut;
+  tcp_stat_var CurrentMSS;
+  tcp_stat_var DupAcksIn;
+  tcp_stat_var AckPktsIn;
+  tcp_stat_var MaxRwinRcvd;
+  tcp_stat_var Sndbuf;
+  tcp_stat_var CurrentCwnd;
+  tcp_stat_var SndLimTimeRwin;
+  tcp_stat_var SndLimTimeCwnd;
+  tcp_stat_var SndLimTimeSender;
+  tcp_stat_var DataBytesOut;
+  tcp_stat_var SndLimTransRwin;
+  tcp_stat_var SndLimTransCwnd;
+  tcp_stat_var SndLimTransSender;
+  tcp_stat_var MaxSsthresh;
+  tcp_stat_var CurrentRTO;
+  tcp_stat_var CurrentRwinRcvd;
+  tcp_stat_var MaxCwnd;
+  tcp_stat_var CongestionSignals;
+  tcp_stat_var PktsOut;
+  tcp_stat_var MinRTT;
+  tcp_stat_var RcvWinScale;
+  tcp_stat_var SndWinScale;
+  tcp_stat_var CongAvoid;
+  tcp_stat_var CongestionOverCount;
+  tcp_stat_var MaxRTT;
+  tcp_stat_var OtherReductions;
+  tcp_stat_var CurTimeoutCount;
+  tcp_stat_var AbruptTimeouts;
+  tcp_stat_var SendStall;
+  tcp_stat_var SlowStart;
+  tcp_stat_var SubsequentTimeouts;
+  tcp_stat_var ThruBytesAcked;
+  /* Additional for web10g */
+  tcp_stat_var MaxSsCwnd;
+  tcp_stat_var MaxCaCwnd;
+};
+
+
 /* web100-pcap */
 #ifdef HAVE_LIBPCAP
 void init_vars(struct spdpair *cur);
@@ -198,40 +249,63 @@
                    int port3);
 void init_pkttrace(I2Addr srcAddr, struct sockaddr *sock_addr,
                    socklen_t saddrlen, int monitor_pipe[2], char *device,
-                   PortPair* pair, char * direction, int compress);
-int check_signal_flags();
+                   PortPair* pair, const char *direction, int compress);
+void force_breakloop();
 #endif
 
 /* web100-util */
-#ifdef HAVE_LIBWEB100
+#if defined(HAVE_LIBWEB100) || defined(HAVE_LIBTCPE)
 void get_iflist(void);
-int web100_init(char *VarFileName);
-int web100_autotune(int sock, web100_agent* agent, web100_connection* cn);
-void web100_middlebox(int sock, web100_agent* agent, web100_connection* cn,
+#ifdef FORCE_WEB100 
+
+typedef web100_agent * tcp_stat_agent;
+typedef web100_connection * tcp_stat_connection;
+typedef web100_snapshot * tcp_stat_snap;
+/* Group only relevent to web100 */
+typedef web100_group * tcp_stat_group;
+/* Log currently unimplemented in web100 */
+typedef web100_log * tcp_stat_log;
+#define tcp_stat_connection_from_socket web100_connection_from_socket
+
+#else /* web10g */
+#ifdef HAVE_LIBTCPE
+
+typedef struct tcpe_client * tcp_stat_agent;
+typedef int tcp_stat_connection;
+typedef struct tcpe_data * tcp_stat_snap;
+/* Not relevent to web10g */
+typedef void * tcp_stat_group;
+/* Log currently unimplemented in web100 */
+typedef void * tcp_stat_log;
+#define tcp_stat_connection_from_socket web10g_connection_from_socket
+
+/* Extra Web10G functions web10g-util.c */
+int web10g_find_val(tcpe_data* data, char * name, struct tcpe_val * value);
+int web10g_get_val(struct tcpe_client * client, int conn, char * name, struct tcpe_val * value);
+int web10g_connection_from_socket(struct tcpe_client * client,int sockfd);
+int web10g_get_remote_addr(struct tcpe_client * client, int conn, char * out, int size);
+
+#endif /* HAVE_LIBTCPE */
+#endif /* FORCE_WEB100 */
+
+int tcp_stat_autotune(int sock, tcp_stat_agent agent, tcp_stat_connection cn);
+int tcp_stat_init(char *VarFileName);
+void tcp_stat_middlebox(int sock, tcp_stat_agent agent, tcp_stat_connection cn,
                       char *results, size_t results_strlen);
-int web100_setbuff(int sock, web100_agent* agent, web100_connection* cn,
-                   int autotune);
-void web100_get_data_recv(int sock, web100_agent* agent, web100_connection* cn,
-                          int count_vars);
-int web100_get_data(web100_snapshot* snap, int ctlsock, web100_agent* agent,
-                    int count_vars);
-int CwndDecrease(web100_agent* agent, char* logname,
+int tcp_stat_setbuff(int sock, tcp_stat_agent agent, tcp_stat_connection cn,
+                   int autotune);/* Not used so no web10g version */
+void tcp_stat_get_data_recv(int sock, tcp_stat_agent agent, tcp_stat_connection cn,
+                          int count_vars);                   
+int tcp_stat_get_data(tcp_stat_snap snap, int testsock, int ctlsock, tcp_stat_agent agent,
+                    int count_vars); 
+                    
+/* TODO web10g version of CwndDecrease */
+int CwndDecrease(tcp_stat_agent agent, char* logname,
                  u_int32_t *dec_cnt, u_int32_t *same_cnt, u_int32_t *inc_cnt);
-int web100_logvars(int *Timeouts, int *SumRTT, int *CountRTT,
-                   int *PktsRetrans, int *FastRetran, int *DataPktsOut,
-                   int *AckPktsOut, int *CurrentMSS, int *DupAcksIn,
-                   int *AckPktsIn, int *MaxRwinRcvd, int *Sndbuf,
-                   int *CurrentCwnd, int *SndLimTimeRwin, int *SndLimTimeCwnd,
-                   int *SndLimTimeSender, int *DataBytesOut,
-                   int *SndLimTransRwin, int *SndLimTransCwnd,
-                   int *SndLimTransSender, int *MaxSsthresh, int *CurrentRTO,
-                   int *CurrentRwinRcvd, int *MaxCwnd, int *CongestionSignals,
-                   int *PktsOut, int *MinRTT, int count_vars, int *RcvWinScale,
-                   int *SndWinScale, int *CongAvoid, int *CongestionOverCount,
-                   int *MaxRTT, int *OtherReductions, int *CurTimeoutCount,
-                   int *AbruptTimeouts, int *SendStall, int *SlowStart,
-                   int *SubsequentTimeouts, int *ThruBytesAcked);
-#endif
+
+int tcp_stat_logvars(struct tcp_vars * vars, int count_vars);
+
+#endif /* defined(HAVE_LIBWEB100) || defined(HAVE_LIBTCPE)*/
 int KillHung(void);
 void writeMeta(int compress, int cputime, int snaplog, int tcpdump);
 
@@ -244,4 +318,5 @@
 sig_atomic_t sig17;
 pid_t sig17_pid[256];
 
+
 #endif  // SRC_WEB100SRV_H_
Index: src/test_results_clt.c
===================================================================
--- src/test_results_clt.c	(revision 796)
+++ src/test_results_clt.c	(working copy)
@@ -296,7 +296,9 @@
 
 /**
  * Print if TCP Selective Acknowledgment Options based on RFC 2018 is on
- *
+ * web100 0 off 1< on - directly from tcp_options_received.sack_ok (Storage size is 4bits)
+ * web10g 1 is on 2 is selfDisabled 3 peerDisabled - split into WillSendSACK
+ * and WillUseSack. For now change web10G to return either 0 off or 1 on.
  * @param SACKEnabled
  */
 void print_SAck_RFC2018(int SACKEnabled) {
@@ -309,40 +311,57 @@
 
 /**
  * Print if Nagle algorithm (rfc 896) is on
+ * web100 1 is on 0 is off
+ * web10g 1 is on 2 is off
  * @param is_nagleenabled
  */
 
 void print_Nagle_RFC896(int is_nagleenabled) {
   printf("RFC 896 Nagle Algorithm: ");
-  if (is_nagleenabled == 0)
+  if (is_nagleenabled == 1)
+    printf("ON\n");
+  else
     printf("OFF\n");
-  else
-    printf("ON\n");
 }
 
 /**
  * Print if Explicit congestion notification to IP is on - RFC 3168 related
+ * web100 0 is off 1 is on
+ * web10g 1 is on 2 is selfDisabled 3 peerDisabled
  * @param is_ECNenabled
  */
 void print_congestion_RFC3168(int is_ECNenabled) {
   printf("RFC 3168 Explicit Congestion Notification: ");
-  if (is_ECNenabled == 0)
-    printf("OFF\n");
-  else
-    printf("ON\n");
+  if (is_ECNenabled == 1)
+		printf("ON\n");
+	else if (is_ECNenabled == 0)
+		printf("OFF\n");
+  else if (is_ECNenabled == 2)
+		printf("OFF - disabled by server\n");
+	else if (is_ECNenabled == 3)
+		printf("OFF - disabled by client\n");
+	else
+		printf("OFF? - unable to determine setting\n");
 }
 
 /**
  * Print details of whether time stamping is on - RFC 1323 related.
- *
+ * web100 1 is on 0 is off - directly from tcp_options_received.tstamp_ok (Storage size is 1bit)
+ * web10g 1 is on 2 is selfDisabled 3 peerDisabled.
  * @param is_timestampenabled
  */
 void print_timestamping_RFC1323(int is_timestampenabled) {
   printf("RFC 1323 Time Stamping: ");
-  if (is_timestampenabled == 0)
-    printf("OFF\n");
-  else
-    printf("ON\n");
+  if (is_timestampenabled == 1)
+		printf("ON\n");
+	else if (is_timestampenabled == 0)
+		printf("OFF\n");
+  else if (is_timestampenabled == 2)
+		printf("OFF - disabled by server\n");
+	else if (is_timestampenabled == 3)
+		printf("OFF - disabled by client\n");
+	else
+		printf("OFF? - unable to determine setting\n");
 }
 
 /**
Index: src/kernel_coalesce.c
===================================================================
--- src/kernel_coalesce.c	(revision 0)
+++ src/kernel_coalesce.c	(revision 0)
@@ -0,0 +1,308 @@
+/* 
+ * This contains functions used by ndt to disable disable packet 
+ * coalescing on network interfaces. This uses the ETHTOOL API to 
+ * access and modify coalescing settings.
+ * 
+ * disable_coalesce is intended to be called first followed by 
+ * revert_coalesce to undo any changes made by disable_coalesce.
+ * 
+ * Author: Richard Sanger
+ */
+
+#include <termios.h>
+#include <fcntl.h>
+#include <errno.h>
+#include <sys/socket.h>
+#include <sys/ioctl.h>
+#include <net/if.h>
+#include <linux/ethtool.h>
+#include <linux/sockios.h>
+#include <stdio.h>
+#include <string.h>
+#include <unistd.h>
+#include <assert.h>
+#include <pcap/pcap.h>
+
+#include "../config.h"
+#include "logging.h"
+
+#define RX_ON     0x1
+#define RX_IRQ_ON   0x2
+#define TX_ON     0x4
+#define TX_IRQ_ON   0x8
+#define RX_ADAPT_ON   0x10
+#define TX_ADAPT_ON   0x20
+
+
+/* We need to keep a copy of the ethtool_coalescing for every interface 
+ * that we change. This is the number of coal_settings data structures
+ * we can keep for the purpose to later revert. 6 seems plenty
+ * since 'lo' isn't included nor any other interface without coalescing
+ * support.
+ */
+#define MAX_IFACES 6
+#define IS_DISABLED(a,b) ((a == 0 || a==1) && (b==0 || b == 1))
+
+/* Keep the original coalescing data so we can switch back to this */
+static struct coal_settings{
+  /* The original coal data */
+  struct ethtool_coalesce coal;
+  /* The interfaces name, if empty we don't revert this one */
+  char name[IFNAMSIZ];
+} eth_coal_org[MAX_IFACES];
+
+/** 
+ * Check if coalescing is already off and fill in the new structure as 
+ * required. See linux/ethtool.h header for discriptions of each field
+ * Note: we cannot set both coalesce_usecs and coalesce_max_frame to 0
+ * this is because 0 means to ignore this setting and only use the other
+ * no 0 one.
+ * 
+ * @param org (in) - the original coalesce data
+ * @param new (out) - the new coalesce data which will have all 
+ *  coalescing turned off upon return.    
+ * 
+ * @return flags indicating which settings have been changed in 'new'.
+ *  If return value is 0 then coalescing is already off and no changes
+ *  to new have been made.
+ */
+static __u32 check_disable_coalesce(const struct ethtool_coalesce * org, 
+                    struct ethtool_coalesce * new){
+  __u32 flags = 0;
+  
+  assert(org);
+  assert(new);
+  
+  /* Copy across the orginal settings into new settings */
+  memcpy(new, org, sizeof(struct ethtool_coalesce));
+  
+  log_println(6, "--rx_coalesce_usecs : %d\n--rx_max_coalesced_frames : %d",
+    org->rx_coalesce_usecs, org->rx_max_coalesced_frames);
+  if(IS_DISABLED(org->rx_coalesce_usecs, org->rx_max_coalesced_frames)){
+    log_println(6, "  RX coalescing is already disabled");
+  } else {
+    flags |= RX_ON;
+    new->rx_coalesce_usecs = 0;
+    new->rx_max_coalesced_frames = 1;
+    log_println(6, "  ndt will attempt to disable RX coalescing");
+  }
+  
+  log_println(6, "--rx_coalesce_usecs_irq : %d\n--rx_max_coalesced_frames_irq : %d",
+    org->rx_coalesce_usecs_irq, org->rx_max_coalesced_frames_irq);
+  if(IS_DISABLED(org->rx_coalesce_usecs_irq, org->rx_max_coalesced_frames_irq)){
+    log_println(6, "  RX irq coalescing is already disabled");
+  } else {
+    flags |= RX_IRQ_ON;
+    new->rx_coalesce_usecs_irq = 0;
+    new->rx_max_coalesced_frames_irq = 1;
+    log_println(6, "  ndt will attempt to disable RX irq coalescing");
+  }
+  
+  log_println(6, "--tx_coalesce_usecs : %d\n--tx_max_coalesced_frames : %d",
+    org->tx_coalesce_usecs, org->tx_max_coalesced_frames);
+  if(IS_DISABLED(org->tx_coalesce_usecs, org->tx_max_coalesced_frames)){
+    log_println(6, "  TX coalescing is already disabled");
+  } else {
+    flags |= TX_ON;
+    new->tx_coalesce_usecs = 0;
+    new->tx_max_coalesced_frames = 1;
+    log_println(6, "  ndt will attempt to disable TX coalescing");
+  }
+  
+  log_println(6, "--tx_coalesce_usecs_irq : %d\n--tx_max_coalesced_frames_irq : %d",
+    org->tx_coalesce_usecs_irq, org->tx_max_coalesced_frames_irq);
+  if(IS_DISABLED(org->tx_coalesce_usecs_irq, org->tx_max_coalesced_frames_irq)){
+    log_println(6, "  TX irq coalescing is already disabled");
+  } else {
+    flags |= TX_IRQ_ON;
+    new->tx_coalesce_usecs_irq = 0;
+    new->tx_max_coalesced_frames_irq = 1;
+    log_println(6, "  ndt will attempt to disable TX irq coalescing");
+  }
+  
+  log_println(6, "--use_adaptive_rx_coalesce : %d", org->use_adaptive_rx_coalesce);
+  if(org->use_adaptive_rx_coalesce == 0){
+    log_println(6, "  Adaptive RX coalescing is already disabled");
+  } else {
+    flags |= RX_ADAPT_ON;
+    new->use_adaptive_rx_coalesce = 0;
+    log_println(6, "  ndt will attempt to disable RX adaptive coalescing");
+  }
+  
+  log_println(6, "--use_adaptive_tx_coalesce : %d", org->use_adaptive_tx_coalesce);
+  if(org->use_adaptive_tx_coalesce == 0){
+    log_println(6, "  Adaptive TX coalescing is already disabled");
+  } else {
+    flags |= TX_ADAPT_ON;
+    new->use_adaptive_rx_coalesce = 0;
+    log_println(6, "  ndt will attempt to disable TX adaptive coalescing");
+  }
+  
+  return flags;
+}
+
+/**
+ * Where possible disables packet coalecsing on all interfaces.
+ * This will log information about any interfaces which it fails on.
+ * 
+ * @param autofix
+ */
+void disable_coalesce(int autofix){
+  struct ethtool_coalesce eth_coal_new;
+  pcap_if_t *alldevs, *dp;
+  /* The current item in the eth_coal_org stucture we are filling */
+  int curr = 0;
+  /* We use ifr for the ETHTOOL query ioctl*/
+  struct ifreq ifr;
+  int skfd;
+  __u32 flags;
+  memset(&ifr, 0, sizeof(ifr));
+  char errbuf[PCAP_ERRBUF_SIZE];
+  
+  /* ioctl needs a file discriptor, make sure we get this without 
+   * needing super user permissions.
+   */
+  if (( skfd = socket(AF_INET, SOCK_DGRAM, 0 ) ) < 0 )
+  {
+    log_println(0, "disable_coalesce - Socket error: %s", strerror(errno));
+    return;
+    }
+  
+  /* Get all the interfaces using pcap since it only lists 
+   * the interfaces it can actually open.
+   */
+  if (pcap_findalldevs(&alldevs, errbuf) != 0) {
+    log_println(0, "disable_coalesce - pcap_findalldevs error: %s", errbuf);
+    close(skfd);
+    return;
+  }
+
+  for(dp = alldevs; dp != NULL; dp = dp->next){
+    /* Ignore any it's a silly device to try and change */
+    if( strcmp("any", dp->name) == 0 || dp->flags & PCAP_IF_LOOPBACK)
+      continue;
+      
+    log_println(6, "Found interface %s", dp->name);
+    /* Try get current coalesce settings */
+    eth_coal_org[curr].coal.cmd = ETHTOOL_GCOALESCE;
+    strncpy(ifr.ifr_name, dp->name, strlen(dp->name));
+    ifr.ifr_data = (char *) &eth_coal_org[curr].coal;
+                                          
+    if (ioctl(skfd, SIOCETHTOOL, &ifr))
+    {
+      switch(errno){
+        case EPERM:
+          log_println(1, "I can not read coalesce settings for %s. "
+            "You should try running ndt as a super user: %s",
+             dp->name, strerror(errno));
+          break;      
+        case EOPNOTSUPP:
+          /* This is actually ok, the card doesn't support coalescing" */
+          log_println(6, "Network interface %s doesn't support"
+              " coalescing: %s", dp->name, strerror(errno));
+          continue;
+        default:
+          log_println(1, "I can not read coalesce settings for"
+              " %s: %s", dp->name, strerror(errno));
+          break;
+      }
+      log_println(0, "WARNING - Link speed detection may be inaccurate for %s.", dp->name);
+      continue;
+    }
+    
+    /* Check what the current coalescing settings are and change if necessary */
+    flags = check_disable_coalesce(&eth_coal_org[curr].coal, &eth_coal_new);
+    
+    if(flags != 0){
+      if (!autofix){
+        log_println(0, "Warning: Link speed detection may be inaccurate for %s.", dp->name);
+        continue;
+      }
+      
+      if (curr == MAX_IFACES)
+        log_println(0, "Ran out of space to store coalescing settings,"
+          " consider rebuiling with an increased MAX_IFACES kernel_coalesce.c");
+      
+      /* Only change coalesce settings if they are actually enabled */
+      eth_coal_new.cmd = ETHTOOL_SCOALESCE;
+      ifr.ifr_data = (char *) &eth_coal_new;
+      if (ioctl(skfd, SIOCETHTOOL, &ifr))
+      {
+        switch(errno){
+          case EPERM:
+            log_println(1, "I can not set new coalesce settings for %s. "
+              "You should try running ndt as a super user: %s"
+              , dp->name, strerror(errno));
+            break;      
+          case EOPNOTSUPP:
+            /* We should have already checked this */
+            log_println(1, "Network interface %s doesn't support coalescing"
+              "However it appeared to when querying for settings: %s"
+              , dp->name, strerror(errno));
+            break;
+          default:
+            log_println(1, "I can not set coalesce settings"
+              " for %s: %s.", dp->name, strerror(errno));
+            break;
+        }
+        log_println(0, "Warning: Link speed detection may be inaccurate for %s.", dp->name);
+        continue;
+      }
+      log_println(6, "Successfully disabled coalescing for %s.", dp->name);
+      /* Mark the slot */
+      strncpy(eth_coal_org[curr].name, dp->name, strlen(dp->name));
+      curr++;
+    }
+  }
+  
+  if (alldevs != NULL)
+    pcap_freealldevs(alldevs);
+  close(skfd);
+  return;
+}
+
+/**
+ * Revert the coalesce setting to their original state before ndt was 
+ * launched. Called after disable_coalesce to revert all of the changes.
+ * This will log information about any interfaces which it fails on. 
+ */
+void revert_coalesce(){
+  struct ifreq ifr;
+  int skfd = -1;
+  int curr;
+  memset(&ifr, 0, sizeof(ifr));
+  
+  /* ioctl needs a file discriptor, make sure we get this without 
+   * needing super user permissions.
+   */ 
+  if (( skfd = socket( AF_INET, SOCK_DGRAM, 0 ) ) < 0 )
+  {
+    log_println(0, "revert_coalesce - Socket error: %s", strerror(errno));
+    return;
+  }
+
+  for(curr = 0; curr < MAX_IFACES; curr++){
+    /* Check if we are at the last valid entry */
+    if(eth_coal_org[curr].name[0] == 0)
+      break;
+    
+    /* Unset coalesce on this interface */
+    strncpy(ifr.ifr_name, eth_coal_org[curr].name, 
+        strlen(eth_coal_org[curr].name));
+    
+    eth_coal_org[curr].coal.cmd = ETHTOOL_SCOALESCE;
+    ifr.ifr_data = (char *) &eth_coal_org;
+    if (ioctl(skfd, SIOCETHTOOL, &ifr))
+    {
+      log_println(0, "I can not undo coalescing settings for %s: %s", 
+        ifr.ifr_name, strerror(errno));
+      continue;
+    }
+    log_println(6, "Successfully reverted coalesce settings for %s.", ifr.ifr_name);
+    /* Free the slot */
+    eth_coal_org[curr].name[0] = 0;
+  }
+  
+  close(skfd);
+  return;
+}
Index: src/web100-pcap.c
===================================================================
--- src/web100-pcap.c	(revision 796)
+++ src/web100-pcap.c	(working copy)
@@ -90,6 +90,19 @@
     pcap_freealldevs(alldevs);
 }
 
+/**
+ * Force the pcap_loop to return, this is safe to call from a signal handler.
+ * Note this will break the loop without a packet being received if
+ * used from a signal handler due to the EINTR interrupting pcaps 'read'.
+ * 
+ * This calls pcap_breakloop with the correct capture.
+ */
+void force_breakloop(){
+  if (pd != NULL) {
+    pcap_breakloop(pd);
+  }
+}
+
 /** Check signal flags and process them accordingly.
  *  If signal indicates request to terminate data collection for the speed bins,
  * 	make packet-pair based speed bins available to the parent process.
@@ -97,7 +110,7 @@
  * @return 1 if data was successfully written
  * 		   0 if no relevant signals were actually received
  */
-int check_signal_flags() {
+static int check_signal_flags() {
   if ((sig1 == 1) || (sig2 == 1)) {
     log_println(
         5,
@@ -135,9 +148,6 @@
       usleep(30000); /* wait here 30 msec, for parent to read this data */
       print_bins(&rev, mon_pipe1);
       usleep(30000); /* wait here 30 msec, for parent to read this data */
-      if (pd != NULL) {
-        pcap_breakloop(pd);
-      }
       if (dumptrace == 1)
         pcap_dump_close(pdump);
       sig1 = 2;
@@ -175,9 +185,6 @@
       usleep(30000); /* wait here 30 msec, for parent to read this data */
       print_bins(&rev, mon_pipe2);
       usleep(30000); /* wait here 30 msec, for parent to read this data */
-      if (pd != NULL) {
-        pcap_breakloop(pd);
-      }
       if (dumptrace == 1)
         pcap_dump_close(pdump);
       sig2 = 2;
@@ -559,10 +566,6 @@
     return;
   }
 
-  if (check_signal_flags()) {
-    return;
-  }
-
   current.sec = h->ts.tv_sec;
   current.usec = h->ts.tv_usec;
   current.time = (current.sec * 1000000) + current.usec;
@@ -787,7 +790,7 @@
 
       void init_pkttrace(I2Addr srcAddr, struct sockaddr *sock_addr,
                          socklen_t saddrlen, int monitor_pipe[2], char *device,
-                         PortPair* pair, char *direction, int compress) {
+                         PortPair* pair, const char*direction, int compress) {
         char cmdbuf[256], dir[256];
         pcap_handler printer;
         u_char * pcap_userdata = (u_char*) pair;
@@ -1046,6 +1049,11 @@
           log_println(5, "pcap_loop exited %s", pcap_geterr(pd));
         }
 
+        /* Send back results to our parent */
+        if(check_signal_flags() == 0){
+          log_println(5, "Whatever happened, we should have a sig flag set");
+        }
+
         pcap_close(pd);
 
         log_println(
Index: src/kernel_coalesce.h
===================================================================
--- src/kernel_coalesce.h	(revision 0)
+++ src/kernel_coalesce.h	(revision 0)
@@ -0,0 +1,14 @@
+/* 
+ * This contains function declaraions for needed by ndt to disable 
+ * packet coalescing on network interfaces.
+ * 
+ * Author: Richard Sanger
+ */
+ 
+#ifndef SRC_KERNEL_COALESCE_H_
+#define SRC_KERNEL_COALESCE_H_
+
+void disable_coalesce(int autofix);
+void revert_coalesce();
+
+#endif  // SRC_KERNEL_COALESCE_H_
Index: src/test_sfw_srv.c
===================================================================
--- src/test_sfw_srv.c	(revision 796)
+++ src/test_sfw_srv.c	(working copy)
@@ -120,8 +120,9 @@
  *			5 - Unable to resolve client address
  */
 
-int test_sfw_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_sfw_srv(int ctlsockfd, tcp_stat_agent agent, TestOptions* options,
                  int conn_options) {
+
   char buff[BUFFSIZE + 1];
   I2Addr sfwsrv_addr = NULL;
   int sfwsockfd, sfwsockport, sockfd, sfwport;
@@ -130,9 +131,14 @@
   fd_set fds;
   struct timeval sel_tv;
   int msgLen, msgType;
+#ifdef FORCE_WEB100
   web100_var* var;
   web100_connection* cn;
   web100_group* group;
+#else /* Must be web10g */
+  struct tcpe_val value;
+  int cn;
+#endif
   int maxRTT, maxRTO;
   char hostname[256];
   int rc;
@@ -169,26 +175,40 @@
     sfwsockport = I2AddrPort(sfwsrv_addr);
     log_println(1, "  -- port: %d", sfwsockport);
 
-    cn = web100_connection_from_socket(agent, ctlsockfd);
+
+    cn = tcp_stat_connection_from_socket(agent, ctlsockfd);
+
     if (cn) {
       // Get remote end's address
+      memset(hostname, 0, sizeof(hostname));
+#ifdef FORCE_WEB100
       web100_agent_find_var_and_group(agent, "RemAddress", &group, &var);
       web100_raw_read(var, cn, buff);
-      memset(hostname, 0, 256);
+      
       // strncpy(hostname, web100_value_to_text(web100_get_var_type(var), buff),
       //         255);
       strlcpy(hostname, web100_value_to_text(web100_get_var_type(var), buff),
               sizeof(hostname));
+#else /* Must be web10g */
+      web10g_get_remote_addr(agent, cn, hostname, sizeof(hostname));
+#endif
 
       // Determine test time in seconds.
       // test-time = max(round trip time, timeout) > 3 ? 3 : 1
 
+#ifdef FORCE_WEB100
       web100_agent_find_var_and_group(agent, "MaxRTT", &group, &var);
       web100_raw_read(var, cn, buff);
       maxRTT = atoi(web100_value_to_text(web100_get_var_type(var), buff));
       web100_agent_find_var_and_group(agent, "MaxRTO", &group, &var);
       web100_raw_read(var, cn, buff);
       maxRTO = atoi(web100_value_to_text(web100_get_var_type(var), buff));
+#else /* Must be web10g */
+      web10g_get_val(agent, cn, "MaxRTT", &value);
+      maxRTT = value.uv32;
+      web10g_get_val(agent, cn, "MaxRTO", &value);
+      maxRTO = value.uv32;
+#endif
       if (maxRTT > maxRTO)
         maxRTO = maxRTT;
       if ((((double) maxRTO) / 1000.0) > 3.0)
